(*
   Gezeigt werden soll, wie Komponenten zur Laufzeit erzeugt werden.
   Die Grundprozeduren sind:     Mybutton[i]:=TButton.Create(Form1);
     Mybutton[i]:=TButton.Create(Form1);      //Speicherplatz reservieren
     {Mybutton[i] wird in die Komponentenkiste von Form1 aufgenommen,
                  und mit der Freigabe von Form1 ebenfalls freigegeben}
     Mybutton[i].Parent:=Form1;               //Ganz wichtig: Wohin?
     Mybutton[i].OnClick:=Form1.MybuttonClick;//Die Methode onclick des Buttons
*)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure MybuttonClick(Sender: Tobject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    Mybutton:array of TButton;
    { Private-Deklarationen }
  public

    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.MybuttonClick(Sender: TObject);
  var i:integer;
begin
   for i:=0 to length(Mybutton)-1 do
     if sender = Mybutton[i] then
       showmessage('Ich bin die Nummer '+inttoStr(i));
end;


procedure TForm1.Button1Click(Sender: TObject);
  var i:integer;
begin //Im Normalfall in Form1.oncreate
  setlength(Mybutton,10);
  for i:=0 to 9 do Begin
     Mybutton[i]:=TButton.Create(Form1);
     Mybutton[i].Parent:=Form1;
     Mybutton[i].width:=45;
     Mybutton[i].caption:='Nr.'+intToStr(i);
     Mybutton[i].top:=0;
     Mybutton[i].left:=50*i;
     Mybutton[i].OnClick:=Form1.MybuttonClick;
  End;
  button1.Hide; //Sonst werden Speicherleichen produziert;
  button2.show;
end;

procedure TForm1.Button2Click(Sender: TObject);
  var i:integer;
begin
  for i:=0 to 9 do Mybutton[i].free; //Automatisch bei Form1.ondestroy
  setlength(Mybutton,0); //Eigentlich nicht ntig
  button2.hide;
  button1.show;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  close;
end;

end.
